Index: Makefile
===================================================================
--- Makefile	(revision 11)
+++ Makefile	(revision 12)
@@ -1,5 +1,5 @@
 ################### Makefile for Path ############
-# (C) PFL 2008
+# (C) PFL 2008-2014
 #################################################
 # Change the value of Machine before compiling
 # You might also have to edit the location of
@@ -26,7 +26,6 @@
 FreeF=-FR
 endif
 
-
 ifeq ($(Machine),g95)
 # Flags for g95 
 COMP=g95 -g   -Wall -fbounds-check
@@ -41,7 +40,6 @@
 ifeq ($(Machine),gfortran)
 # Flags for gfortran
 COMP=gfortran  -pedantic -std=gnu 
-#COMP=g95  -fbounds-check -g -ftrace=full -ftrace=frame  -save-temps
 F90=${COMP}
 F77=${COMP}
 LIBMATH= -llapack -lblas
@@ -49,7 +47,6 @@
 FreeF=-ffree-form
 endif
 
-
 ifeq ($(Machine),pgf)
 # Flags for PGF
 COMP=pgf90
@@ -144,29 +141,11 @@
 FreeF=-FR
 endif
 
-
-
-ifeq ($(Machine),arqP)
-# Flags for arq Ifort
-COMP=ifort
-#F90=${COMP}   -g -check bounds  -check format -check uninit  -traceback
-F90=${COMP}   -g -check all  -traceback
-F77=${F90}
-#F90=${COMP}  
-LIBMATH= -L/opt/intel/Compiler/11.1/064/mkl/lib/64  \
-  -Wl,--start-group -lmkl_intel_lp64 -lmkl_sequential \
-           -lmkl_core -Wl,--end-group
-LINK=${COMP} -lguide -lpthread   -L/usr/lib/
-FreeF=-FR
-endif
-
 ifeq ($(Machine),arqg)
 # Flags for arq GFortran
 COMP=gfortran -g -fbacktrace -fbounds-check -Wall -Wextra
 F90=${COMP}  
 F77=${F90}
-#F90=${COMP}  
-F90=${COMP}
 LIBMATH= -llapack -lblas
 LINK=${COMP}  -L/usr/lib/  
 FreeF=-ffree-form
@@ -233,6 +212,7 @@
       ReadInput_mopac.f90 \
       ReadInput_siesta.f90 \
       ReadAnaList.f90 \
+      Set_FileDelim.f90 \
       PrintAnaList.f90 \
       AnaPath.f90 \
       AnalyzeGeom.f90 \
@@ -265,7 +245,6 @@
       egrad_test_2D.f90 \
       egrad_vasp.f90 \
       egrad_turbomole.f90 \
-      egrad_chamfre.f90 \
       egrad_LEPS.f90 \
       CalcHess.f90 \
       Hupdate_all.f90 \
@@ -292,9 +271,7 @@
       Space_GEDIIS_all.f90 \
       Space_all.f90 \
       freemv.f90 \
-      Mat_util.f90 \
-      refsor.f90 \
-      Ginvse.f90
+      Mat_util.f90 
 
 SRC0= ConvertNumAt.f90 \
       CheckPeriodicBound.f90 \
@@ -310,6 +287,7 @@
       bib_oper.f90 \
       VectorPer.f90 \
       ZmatBuild.f90 \
+      WriteMixed_Gaussian.f90 \
       CalcCnct.f90 \
       ConvXyzZmat.f90 \
       ConvXyzMixed.f90 \
@@ -326,9 +304,6 @@
       Mixed2cart.f90 \
       Write_path.f90  \
       Write_vasp.f90  \
-      Std_ori.f90 \
-      Tensor.f90 \
-      cmshft.f90 \
       sinangle.f90 \
       Header.f90 \
       gaussj.f90  \
@@ -339,8 +314,7 @@
 
 MOD = VarTypes.mod \
       Path_module.mod \
-      Io_module.mod  \
-      m_mrgrnk.mod
+      Io_module.mod 
       
 MODo = $(MOD:.mod=.o)
 MODSRC = $(MOD:.mod=.f90)
@@ -350,21 +324,6 @@
 EXAMPLES = Path.valid  parameter.dat
 
 
-###############################################################
-#
-# For now, we also give Lapack and Blas source files in case
-# the libraries are not found by the user
-#
-###############################################################
-SRCLAPACKD=$(wildcard ./lapack/double/*.f )
-SRCLAPACKU=$(wildcard ./lapack/util/*.f )
-SRCBLAS=$(wildcard ./blas/*.f )
-
-OBJLAPACK=$(SRCLAPACKD:.f=.o) \
-        $(SRCLAPACKU:.f=.o)
-
-OBJBLAS=$(SRCBLAS:.f=.o)
-
 all: path utils
 
 install: 
@@ -378,8 +337,8 @@
 	@echo ""
 	@echo "Path.exe has been created."
 
-path_noL: ${MODo} ${OBJ} lapack blas
-	${LINK} -o Path.exe ${OBJ} ${MODo}  ./lapack/lapack.a ./blas/blas.a
+path_noL: ${MODo} ${OBJ} 
+	${LINK} -o Path.exe ${OBJ} ${MODo}  ./liblapack.a ./librefblas.a
 	@echo ""
 	@echo "Path.exe has been created."
 
@@ -395,23 +354,11 @@
 xyz2path: ../utils/Xyz2Path.f90 ../utils/Xyz2Path.param 
 	${F90} -o ../utils/xyz2path ../utils/Xyz2Path.f90
 
-tgz:  ${SRC0} ${SRC} Makefile ${EXAMPLES} ${MODSRC} ${SRCLAPACKD} ${SRCLAPACKU} ${SRCBLAS} 
-	tar -cvf OpenPath_${Version}.tar ${SRC0} ${SRC} Makefile ${EXAMPLES} ${MODSRC}
-	gzip OpenPath_${Version}.tar 
-	mv  OpenPath_${Version}.tar.gz OpenPath_${Version}.tgz
-	@echo "OpenPath_${Version}.tgz  has been created."
-
-lapack: ${OBJLAPACK} 
-	ar rcs ./lapack/lapack.a ${OBJLAPACK}
-
-blas: ${OBJBLAS}
-	ar rcs ./blas/blas.a ${OBJBLAS}
-
 clean:
-	rm -f *~ "#"* *.s ${OBJ} *.mod  ${MODo} ${OBJLAPACK} ${OBJBLAS}  
+	rm -f *~ "#"* *.s ${OBJ} *.mod  ${MODo}
 
 veryclean: clean
-	rm -f Path.exe ./lapack/lapack.a  ./blas/blas.a ../utils/xyz2scan ../utils/xyz2path
+	rm -f Path.exe ../utils/xyz2scan ../utils/xyz2path
 
 %.o : %.mod
 