Index: c-i-a-b.common
===================================================================
--- c-i-a-b.common	(revision 22)
+++ c-i-a-b.common	(revision 23)
@@ -2,13 +2,20 @@
 # Constants that no one should not change.
 CONST_NULL_DISK_SIZE=0G # For several configuration files.
 CONST_NO_DHCP="NO_DHCP"
+CONST_FRONT_END_TEMPLATE_NAME="front-end.cfg"
 #
 # Constant that may change with another Xen version.
-CONST_XEN_DHCP_STANZA="dhcp=          ='dhcp'"
+CONST_XEN_BRIDGE_PREFIX="bridge="
+CONST_XEN_DHCP_STANZA="dhcp        ='dhcp'"
+CONST_XEN_CONFIG_DIR="/etc/xen"
 CONST_XEN_DOM0_CPUS_ALL="(dom0-cpus 0)"
 CONST_XEN_DOM0_NAME=Domain-0
+CONST_XEN_IP_PREFIX="ip="
+CONST_XEN_MAC_PREFIX="mac="
 CONST_XEN_NOSWAP="noswap = 1" # For /etc/xen-tools/xen-tools.conf.
 CONST_XEN_NETWORK_SCRIPT_KEYWORD=network-script # For /etc/xen/xend-config.sxp.
+CONST_XEN_VIF_STANZA_POSTFIX="' ]"
+CONST_XEN_VIF_STANZA_PREFIX="vif         = [ '"
 #
 # Common user defined configuration variables
 #
@@ -17,60 +24,67 @@
 CLUSTER_BRIDGE_SCRIPT=network-bridge-internal
 CLUSTER_BRIDGE_STANZA="($CONST_NETWORK_SCRIPT_KEYWORD $CLUSTER_BRIDGE_SCRIPT)"
 CLUSTER_EXTERNAL_ADDRESSES_BY_DHCP=1
+CLUSTER_EXTERNAL_MAC_PREFIX="00:16:3E:33:A6:"
 CLUSTER_IMAGE=full
 CLUSTER_DOMAIN_NAME=ciab.lip.ens-lyon.fr
 CLUSTER_NOSWAP="$CONST_XEN_NOSWAP"
+CLUSTER_STATIC_EXTERNAL_PREFIX="140.77.15"
 CLUSTER_STATIC_NETWORK_PREFIX="192.168.1"
 CLUSTER_SWAP_SIZE=$CONST_NULL_DISK_SIZE
+#
 COMPUTE_NODE_BRIDGE=$CLUSTER_BRIDGE_NAME
 COMPUTE_NODE_CPUS_FILE=compute-nodes-cpus
 COMPUTE_NODE_DISK_MOUNT_POINT=/mnt/compute-node-system-disk
 COMPUTE_NODE_INTERFACES_TEMPLATE=interfaces.compute-node
 COMPUTE_NODE_KERNEL=/boot/vmlinuz-`uname -r`
-COMPUTE_NODE_RAMDISK=/boot/initrd.img-`uname -r`
 COMPUTE_NODE_MAC_ADDRESS_PREFIX="00:16:3E:0F:6A"
 COMPUTE_NODE_MAX_NUM=250
 COMPUTE_NODE_MEMORY=3072
-COMPUTE_NODE_MODEL_EXTERNAL_MAC_ADDRESS="00:16:3E:33:A6:01"
+COMPUTE_NODE_MODEL_EXTERNAL_MAC_ADDRESS="${CLUSTER_EXTERNAL_MAC_PREFIX}01"
 COMPUTE_NODE_MODEL_STATIC_NETWORK_POSTFIX=252
 COMPUTE_NODE_MODEL_STATIC_IP_EXTERNAL=
-COMPUTE_NODE_MODEL_NAME="compute-node-model"
+COMPUTE_NODE_MODEL_HOST_NAME="tamadi-1-cnm"
 COMPUTE_NODE_NAME_PREFIX="compute-node-"
+COMPUTE_NODE_RAMDISK=/boot/initrd.img-`uname -r`
 COMPUTE_NODE_STATIC_NETWORK_PREFIX=$CLUSTER_STATIC_NETWORK_PREFIX
+COMPUTE_NODE_SWAP_DISK_POSTFIX="-swap"
+COMPUTE_NODE_SWAP_DISK_PREFIX="compute-node-"
+COMPUTE_NODE_SWAP_DISK_SIZE=1G
+SWAP_DISK_VOLUME_GROUP=/dev/vg_fast
 DHCP_HOSTSFILE_BASENAME=dhcp-hostsfile
 DOM0_CPUS_LIST="0 4"
 DOM0_CPUS_NUM=2
 DOM0_CPUS_CLAUSE="(dom0-cpus $DOM0_CPUS_NUM)"
 FRONT_END_CPUS_LIST="8 12 16"
-FRONT_END_EXTERNAL_MAC_ADDRESS="00:16:3E:33:A6:02"
-FRONT_END_MEMORY=8G
-FRONT_END_HOME_DISK_SIZE=512G
+FRONT_END_EXTERNAL_MAC_ADDRESS="${CLUSTER_EXTERNAL_MAC_PREFIX}02"
+FRONT_END_HOME_DISK=front-end-home-disk
+FRONT_END_HOME_DISK_FILE_SYSTEM=ext3
+#FRONT_END_HOME_DISK_SIZE=512G
+FRONT_END_HOME_DISK_SIZE=10G
 FRONT_END_HOME_VOLUME_GROUP=vg_slow
 FRONT_END_HOME_VOLUME_GROUP_DEVICE="/dev/$FRONT_END_HOME_VOLUME_GROUP"
-FRONT_END_HOST_NAME="front-end"
+FRONT_END_HOST_NAME="tamadi-1-fe"
 FRONT_END_INTERFACES_TEMPLATE=interfaces.front-end
 FRONT_END_KERNEL=/boot/vmlinuz-`uname -r`
+FRONT_END_MEMORY=8G
+FRONT_END_STATIC_NETWORK_POSTFIX=251
+FRONT_END_CLUSTER_STATIC_IP="$CLUSTER_STATIC_NETWORK_PREFIX.$FRONT_END_STATIC_NETWORK_POSTFIX"
+FRONT_END_EXTERNAL_STATIC_IP="$CLUSTER_STATIC_NETWORK_PREFIX.$FRONT_END_STATIC_NETWORK_POSTFIX"
 FRONT_END_RAMDISK=/boot/initrd.img-`uname -r`
-FRONT_END_STATIC_NETWORK_POSTFIX=251
-FRONT_END_STATIC_IP_CLUSTER="$CLUSTER_STATIC_NETWORK_PREFIX.$FRONT_END_STATIC_NETWORK_POSTFIX"
-FRONT_END_STATIC_IP_EXTERNAL="$CLUSTER_STATIC_NETWORK_PREFIX.$FRONT_END_STATIC_NETWORK_POSTFIX"
 FRONT_END_SWAP_DISK="frontend-swap"
 #FRONT_END_SWAP_DISK_SIZE=$CONST_NULL_DISK_SIZE # 0G means no swap disk.
 FRONT_END_SWAP_DISK_SIZE=1G # 0G means no swap disk.
 FRONT_END_SWAP_VOLUME_GROUP=vg_fast
 FRONT_END_SWAP_VOLUME_GROUP_DEVICE="/dev/$FRONT_END_SWAP_VOLUME_GROUP"
 FRONT_END_SYSTEM_DISK="frontend-system-disk"
-FRONT_END_SYSTEM_DISK_SIZE=46G
+#FRONT_END_SYSTEM_DISK_SIZE=46G
+FRONT_END_SYSTEM_DISK_SIZE=10G
 FRONT_END_SYSTEM_DISK_FILE_SYSTEM=ext3
 FRONT_END_SYSTEM_DISK_MOUNT_POINT=/mnt/frontend-system-disk
 FRONT_END_SYSTEM_VOLUME_GROUP=vg_fast
 FRONT_END_SYSTEM_VOLUME_GROUP_DEVICE="/dev/$FRONT_END_SYSTEM_VOLUME_GROUP"
 FRONT_END_VCPUS_NUM=3
 HOSTS_FILE_BASENAME=hosts
-SWAP_DISK_LOGICAL_VOLUME=/dev/vg_fast
-SWAP_DISK_POSTFIX="-swap"
-SWAP_DISK_PREFIX="compute-node-"
-SWAP_DISK_SIZE=1G
 SYSTEM_DISK_CLONE_POSTFIX="-disk"
 SYSTEM_DISK_CLONE_PREFIX=$COMPUTE_NODE_NAME_PREFIX
 SYSTEM_DISK_CLONE_SIZE=20G # Half of the master size.