Index: add-iscsi-volume
===================================================================
--- add-iscsi-volume	(revision 39)
+++ add-iscsi-volume	(revision 40)
@@ -46,11 +46,11 @@
 do
    CHECK_TID=$(($CHECK_TID + 1))
 done 
-echo "*** iscsi volume name : ***" 
+echo "*** iscsi volume name: ***" 
 while read inputline
 do
    NAME_ISCSI=$inputline 
-   echo "*** Are you sur : $inputline ? (y/n) ***"
+   echo "*** Are you sure: $inputline ? (y/n) ***"
    
    while read inputConfirm
    do
@@ -58,7 +58,7 @@
       then
          break
       fi
-      echo "*** Are you sur : $inputline ? (y/n) ***" 
+      echo "*** Are you sure: $inputline ? (y/n) ***" 
    done
 
    if [ "$inputConfirm" = "y" ]
@@ -67,23 +67,23 @@
    fi
    if [ "$inputConfirm" != "y" ]
    then
-      echo "*** iscsi volume name : ***"
+      echo "*** iscsi volume name: ***"
    fi
 done
 
 echo ""
-echo "*** Step I : Initialization of TID and iscsi volume name ***"
+echo "*** Step I: Initialization of TID and iscsi volume name ***"
 TODAY=$(date +%Y%m%d%H%M%S)
 ietadm --op new --tid=$CHECK_TID --params Name=iqn.$TODAY:$(hostname)-ens-zfs-iscsi-$NAME_ISCSI
 if [ $? -eq 0 ]
 then
-   echo "*** Path of zfs device (zvol) to export : ***"
+   echo "*** Path of zfs device (zvol) to export: ***"
    
 
    while read -e inputline
    do
       PATH_ZVOL=$inputline
-      echo "*** Are you sur : $inputline ? (y/n) ***"
+      echo "*** Are you sure: $inputline ? (y/n) ***"
 
       while read inputConfirm
       do
@@ -91,37 +91,37 @@
          then
             break
          fi
-         echo "*** Are you sur : $inputline ? (y/n) ***"
+         echo "*** Are you sure: $inputline ? (y/n) ***"
       done
 
       if [ "$inputConfirm" = "y" ]
       then
-         echo "*** Check if zvol path exists ...***"
+         echo "*** Check if zvol path exists... ***"
          ls -l $PATH_ZVOL
          if [ $? -eq 0 ]
          then
-            echo "*** The path is valid ..."
+            echo "*** The path is valid... "
             break
          else
-            echo "*** Path doesn't exist ...."
+            echo "*** Path doesn't exist... "
          fi
       fi
       if [ "$inputConfirm" != "y" ]
       then
-         echo "*** Path of zfs device (zvol) to export : ***"
+         echo "*** Path of zfs device (zvol) to export: ***"
       fi
    done
   
    echo "" 
-   echo "*** Step II : initialization of the PATH and iscsi volume LUN ***"
+   echo "*** Step II: initialization of the PATH and iscsi volume LUN ***"
    if [ $? -eq 0 ]
    then
-     echo "*** ISCSI export Type (fileio/blockio) : ***"
+     echo "*** ISCSI export Type (fileio/blockio): ***"
      
      while read inputline
      do
         TYPE_EXPORT=$inputline
-        echo "*** Are you sur : $inputline ? (y/n) ***"
+        echo "*** Are you sure: $inputline ? (y/n) ***"
 
         while read inputConfirm
         do
@@ -129,33 +129,33 @@
            then
               break
            fi
-           echo "*** Are you sur : $inputline ? (y/n) ***"
+           echo "*** Are you sure: $inputline ? (y/n) ***"
         done
 
         if [ "$inputConfirm" = "y" ]
         then
-           echo "*** Check if the parameter is valid ...***"
+           echo "*** Check if the parameter is valid... ***"
            if [ "$TYPE_EXPORT" = "fileio" ]||[ "$TYPE_EXPORT" = "blockio" ]
            then
               break
            else
-              echo "*** ISCSI export Type (fileio/blockio) : ***"
+              echo "*** ISCSI export Type (fileio/blockio): ***"
            fi
         fi
         if [ "$inputConfirm" != "y" ]
         then
-           echo "*** ISCSI export Type (fileio/blockio) : ***"
+           echo "*** ISCSI export Type (fileio/blockio): ***"
         fi
      done
 
    echo "" 
-   echo "*** Step II.B : initialization iscsi IOMode ***"
-     echo "*** ISCSI IOMode (ro/wt) : ***"
+   echo "*** Step II.B: initialization iscsi IOMode ***"
+     echo "*** ISCSI IOMode (ro/wt): ***"
      
      while read inputline
      do
         iomode=$inputline
-        echo "*** Are you sur : $inputline ? (y/n) ***"
+        echo "*** Are you sure: $inputline ? (y/n) ***"
 
         while read inputConfirm
         do
@@ -163,59 +163,59 @@
            then
               break
            fi
-           echo "*** Are you sur : $inputline ? (y/n) ***"
+           echo "*** Are you sure: $inputline ? (y/n) ***"
         done
 
         if [ "$inputConfirm" = "y" ]
         then
-           echo "*** Check if the parameter is valid ...***"
+           echo "*** Check if the parameter is valid... ***"
            if [ "$iomode" = "ro" ]||[ "$iomode" = "wt" ]
            then
               break
            else
-              echo "*** ISCSI IOMode (ro/wt) : ***"
+              echo "*** ISCSI IOMode (ro/wt): ***"
            fi
         fi
         if [ "$inputConfirm" != "y" ]
         then
-           echo "*** ISCSI IOMode (ro/wt) : ***"
+           echo "*** ISCSI IOMode (ro/wt): ***"
         fi
      done
      
      echo ""
-     echo "*** Step III : initialization of export Type and iscsi IOMode ***"
+     echo "*** Step III: initialization of export Type and iscsi IOMode ***"
      ietadm --op new --tid=$CHECK_TID --lun=0 --params Path=$PATH_ZVOL,Type=$TYPE_EXPORT,IOMode=$iomode
      if [ $? -eq 0 ]
      then
 
        echo ""
-       echo "*** Step IV : Login and password ***"
-       echo "*** Do you enable a restriction login/password : (y/n)"
+       echo "*** Step IV: Login and password ***"
+       echo "*** Do you enable a restriction login/password: (y/n)"
        while read inputline
        do
            if [ "$inputline" != "y" ] && [ "$inputline" != "n" ]
            then
-              echo "*** Do you enable a restriction login/password : (y/n)"
+              echo "*** Do you enable a restriction login/password: (y/n)"
            else
              if [ "$inputline" = "y" ]
              then
-                 echo "*** Give a login :"
+                 echo "*** Give a login:"
                  while read inputlogin
                  do
                    if [ "$inputlogin" != "" ]
                    then
                       break
                    else
-                      echo "*** Give a login :"
+                      echo "*** Give a login:"
                    fi
                   done
 
-                  echo "*** Give a password :"
+                  echo "*** Give a password:"
                   while read inputpass
                   do
                      if [ "$inputpass" = "" ]
                      then
-                        echo "*** Give a password :"
+                        echo "*** Give a password:"
                      else
                         break
                      fi
@@ -226,8 +226,8 @@
                     echo "*** Authentication Configuration [OK]"
        
                     echo ""
-                    echo "*** Step IV : Writting in file ietd.conf ***"
-                    echo "*** Backup of /etc/iet/ietd.conf ..."
+                    echo "*** Step IV: Writting in file ietd.conf ***"
+                    echo "*** Backup of /etc/iet/ietd.conf... "
 
                     cp /etc/iet/ietd.conf /etc/iet/ietd.conf.$TODAY
 
@@ -248,8 +248,8 @@
                  break
              else
                     echo ""
-                    echo "*** Step IV : Writting in file ietd.conf ***"
-                    echo "*** Backup of /etc/iet/ietd.conf ..."
+                    echo "*** Step IV: Writting in file ietd.conf ***"
+                    echo "*** Backup of /etc/iet/ietd.conf... "
 
                     cp /etc/iet/ietd.conf /etc/iet/ietd.conf.$TODAY
 
@@ -270,37 +270,37 @@
        done
 
      else
-       echo "*** Problem during the step III (initialization of iscsi export Type). Canceled Process ...***"
+       echo "*** Problem during step III (initialization of iscsi export Type). Canceled process... ***"
        ietadm --op delete --tid=$CHECK_TID
      fi
      
    else
-      echo "*** Problem during the step II (initialization of PATH and  iscsi volume LUN). Canceled Process ...***"
+      echo "*** Problem during step II (initialization of PATH and iscsi volume LUN). Canceled process... ***"
       ietadm --op delete --tid=$CHECK_TID
    fi
 
 else
-   echo "*** Problem during the step I (initialization of TID and iscsi volume name). Canceled Process ...***"
+   echo "*** Problem during step I (initialization of TID and iscsi volume name). Canceled process... ***"
    ietadm --op delete --tid=$CHECK_TID
 fi
 }
 
 function usage {
 
-echo "syntax : " 1>&2
+echo "syntax: " 1>&2
 echo "add-iscsi-volume [OPTIONS]" 1>&2
 echo "" 1>&2
 echo "OPTIONS :" 1>&2
 echo "-h : display this message" 1>&2
 echo "-d : path device to iscsi export" 1>&2
-echo "-T : export type. Only fileio or blockio" 1>&2
-echo "-L : lun. Only numeric value." 1>&2
+echo "-T : export type (Only fileio or blockio)" 1>&2
+echo "-L : lun (Only numeric values)" 1>&2
 echo "-o : IO Mode : ro (Read Only) or wt (Read Write)" 1>&2
 echo "-l : login if you want a CHAP authentication" 1>&2
 echo "-p : password if you want a CHAP authentication" 1>&2
-echo "-R : Specify a list of restricted IP. Separate such IP by a ;" 1>&2
-echo "-t : name of zfs volume. This field is used to generate alias name iscsi" 1>&2
-echo "-i : interactive mode. This option is not compatible with others" 1>&2
+echo "-R : Specify a list of restricted IP (Separated by a ;)" 1>&2
+echo "-t : name of zfs volume (This field is used to generate alias name iscsi)" 1>&2
+echo "-i : interactive mode (This option is not compatible with others)" 1>&2
 
 }
 