Index: del-iscsi-volume
===================================================================
--- del-iscsi-volume	(revision 39)
+++ del-iscsi-volume	(revision 40)
@@ -34,7 +34,7 @@
   fi
   if [ $TID_ISACTIVE -eq 0 ]
   then
-     echo "iscsi volume in use, please disconnect all clients " 1>&2
+     echo "iscsi volume in use, please disconnect all clients first " 1>&2
      exit 1
   fi
   TID_LISTED=$(echo $line |awk '(/tid:/) { print $1 }')
@@ -52,9 +52,11 @@
 ietadm --op delete --tid=$TID2DEL
 if [ $? -eq 0 ]
 then
-   echo "*** La suppression via la commande ietadm s'est termine correctement"
+#   echo "*** La suppression via la commande ietadm s'est termine correctement"
+   echo "*** Removal, via ietadm command, ended correctly "
    echo ""
-   echo "*** Vérification et suppression du volume dans le fichier /etc/iet/ietd.conf ..."
+#   echo "*** Vérification et suppression du volume dans le fichier /etc/iet/ietd.conf ..."
+   echo "*** Checking and removal of volume's entry in /etc/iet/ietd.conf... "
 
    COPY_LINE=0
    >/tmp/.buffer_ietd.conf
@@ -76,26 +78,32 @@
       fi
 
     done < "/etc/iet/ietd.conf"
-    echo "*** Sauvegarde du fichier /etc/iet/ietd.conf ..."
+#    echo "*** Sauvegarde du fichier /etc/iet/ietd.conf ..."
+    echo "*** Backup of file /etc/iet/ietd.conf... "
     TODAY=$(date +%Y%m%d%H%M%S)
     cp /etc/iet/ietd.conf /etc/iet/ietd.conf.$TODAY
     cp /tmp/.buffer_ietd.conf /etc/iet/ietd.conf
 
 
    echo ""
-   echo "*** Vérification /proc/net/iet/volume :"
+#   echo "*** Vérification /proc/net/iet/volume :"
+   echo "*** Checking /proc/net/iet/volumes: "
    cat /proc/net/iet/volume
 
    echo ""
-   echo "*** Verification repertoire /etc/iet :"
+#   echo "*** Verification repertoire /etc/iet :"
+   echo "*** Checking /etc/iet directory: "
    ls -ltr /etc/iet
 
    echo ""
-   echo "*** Operation de suppression [OK] ..."
+#   echo "*** Operation de suppression [OK] ..."
+   echo "*** Removal operation [OK] "
 else
 
-   echo "*** Un probleme est survenu lors de la tentive de suppresion du volume iscsi TID:$TID2DEL"
-   echo "*** Veuillez vérifier que le volume n'est pas en cours d'uilisation (cat /proc/net/iet/session) sinon contacter l'admin en charge de ce serv ce"
+#   echo "*** Un probleme est survenu lors de la tentative de suppression du volume iscsi TID:$TID2DEL"
+#   echo "*** Veuillez vérifier que le volume n'est pas en cours d'utilisation (cat /proc/net/iet/session) sinon contacter l'admin en charge de ce service"
+   echo "*** A problem occurred while trying to delete iscsi volume TID:$TID2DEL"
+   echo "*** Please verify that this volume is not in use (cat /proc/net/iet/session) otherwise contact the BOFH in charge"
 fi
 
 
@@ -104,14 +112,17 @@
 
 function interactive {
 
-echo "*** Choix du volume ISCSI a supprimer ***"
+#echo "*** Choix du volume ISCSI a supprimer ***"
+echo "*** ISCSI volume to delete: ***"
 cat /proc/net/iet/session
 
-echo "*** Saisir le TID du volume iscsi a supprimer : ***" 
+#echo "*** Saisir le TID du volume iscsi a supprimer : ***" 
+echo "*** Please enter TID from iscsi volume to delete: ***"
 while read inputline
 do
    TID2DEL=$inputline 
-   echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+#   echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+   echo "*** Are you sure: $inputline ? (y/n) ***"
    
    while read inputConfirm
    do
@@ -119,7 +130,8 @@
       then
          break
       fi
-      echo "*** Etes-vous certain de vouloir supprimer le TID : $inputline ? (y/n) ***" 
+#      echo "*** Etes-vous certain de vouloir supprimer le TID : $inputline ? (y/n) ***" 
+      echo "*** Are you sure to delete this TID: $inputline ? (y/n) ***"
    done
 
    if [ "$inputConfirm" = "y" ]
@@ -128,17 +140,21 @@
    fi
    if [ "$inputConfirm" != "y" ]
    then
-      echo "*** Saisir le TID du volume iscsi a supprimer : ***" 
+#      echo "*** Saisir le TID du volume iscsi a supprimer : ***" 
+      echo "*** Please enter TID from iscsi volume to delete: ***"
    fi
 done
 
-echo "**** Recuperation de la propriété Target (identifiant utilise dans le fichier /etc/iet/ietd.conf) ..."
+#echo "**** Recuperation de la propriété Target (identifiant utilise dans le fichier /etc/iet/ietd.conf) ..."
+echo "**** Retrieval of Target property (id used in /etc/iet/ietd.conf)... "
 TARGET=$(cat /proc/net/iet/session |grep -i tid:$TID2DEL |cut -d ":" -f3)
 
-echo "Nom de la target a rechercher dans /etc/iet/ietd.conf : $TARGET"
+#echo "Nom de la target a rechercher dans /etc/iet/ietd.conf : $TARGET"
+echo "Target name to search in /etc/iet/ietd.conf: $TARGET"
 
 echo ""
-echo "**** Check si le volume est en cours d'utilisation ..."
+#echo "**** Check si le volume est en cours d'utilisation ..."
+echo "**** Checking if volume is in use... "
 
 
 TID_FIND=1
@@ -156,7 +172,8 @@
   fi
   if [ $TID_ISACTIVE -eq 0 ]
   then
-     echo "Le volume isci est en cours d'utilisation, suppression impossible"
+#     echo "Le volume isci est en cours d'utilisation, suppression impossible"
+     echo "ISCSI Volume is in use, cannot delete."
      exit 1
   fi
   TID_LISTED=$(echo $line |awk '(/tid:/) { print $1 }')
@@ -171,15 +188,18 @@
  fi
 done
 
-echo "*** Debut de la procédure de suppression ..."
+#echo "*** Debut de la procédure de suppression ..."
+echo "*** Beginning delete procedure... "
 echo ""
 
 ietadm --op delete --tid=$TID2DEL
 if [ $? -eq 0 ]
 then
-   echo "*** La suppression via la commande ietadm s'est termine correctement"
+#   echo "*** La suppression via la commande ietadm s'est termine correctement"
+   echo "*** Removal, via ietadm command, ended correctly "
    echo ""
-   echo "*** Vérification et suppression du volume dans le fichier /etc/iet/ietd.conf ..."
+#   echo "*** Vérification et suppression du volume dans le fichier /etc/iet/ietd.conf ..."
+   echo "*** Checking and removal of volume's entry in /etc/iet/ietd.conf... "
 
    COPY_LINE=0
    >/tmp/.buffer_ietd.conf
@@ -201,28 +221,34 @@
       fi 
 
     done < "/etc/iet/ietd.conf"
-    echo "*** Sauvegarde du fichier /etc/iet/ietd.conf ..."
+#    echo "*** Sauvegarde du fichier /etc/iet/ietd.conf ..."
+    echo "*** Backup of file /etc/iet/ietd.conf... "
     TODAY=$(date +%Y%m%d%H%M%S)
     cp /etc/iet/ietd.conf /etc/iet/ietd.conf.$TODAY
     cp /tmp/.buffer_ietd.conf /etc/iet/ietd.conf
        
 
    echo ""
-   echo "*** Vérification /proc/net/iet/volume :"
+#   echo "*** Vérification /proc/net/iet/volume :"
+   echo "*** Checking /proc/net/iet/volumes: "
    cat /proc/net/iet/volume
 
    echo ""
-   echo "*** Verification repertoire /etc/iet :"
+#   echo "*** Verification repertoire /etc/iet :"
+   echo "*** Checking /etc/iet directory: "
    ls -ltr /etc/iet
 
    echo ""
-   echo "*** Operation de suppression [OK] ..."
+#   echo "*** Operation de suppression [OK] ..."
+   echo "*** Removal operation [OK] "
 else
 
-   echo "*** Un probleme est survenu lors de la tentive de suppresion du volume iscsi TID:$TID2DEL"
-   echo "*** Veuillez vérifier que le volume n'est pas en cours d'uilisation (cat /proc/net/iet/session) sinon contacter l'admin en charge de ce service"
+#   echo "*** Un probleme est survenu lors de la tentive de suppresion du volume iscsi TID:$TID2DEL"
+#   echo "*** Veuillez vérifier que le volume n'est pas en cours d'uilisation (cat /proc/net/iet/session) sinon contacter l'admin en charge de ce service"
+   echo "*** A problem occurred while trying to delete iscsi volume TID:$TID2DEL"
+   echo "*** Please verify that this volume is not in use (cat /proc/net/iet/session) otherwise contact the BOFH in charge"
 fi
-echo "*** FIN ***"
+echo "*** END ***"
 }
 
 while getopts "iT:h" OPTION