Index: c-i-a-b.common
===================================================================
--- c-i-a-b.common	(revision 44)
+++ c-i-a-b.common	(revision 45)
@@ -4,7 +4,9 @@
 # Compute nodes from 1 to 250
 CONST_COMPUTE_NODE="compute-node"
 CONST_COMPUTE_NODE_MAX_NUM=250
+CONST_COMPUTE_NODE_MODEL="compute-node-model"
 CONST_COMPUTE_NODE_MODEL_CLUSTER_STATIC_NETWORK_POSTFIX=252
+CONST_COMPUTE_NODE_MODEL_XEN_TEMPLATE_NAME="${CONST_COMPUTE_NODE_MODEL}.cfg"
 CONST_DHCP_HOSTS_FILE_BASENAME=dhcp-hostsfile
 CONST_FRONT_END_CLUSTER_STATIC_NETWORK_POSTFIX=251
 CONST_FRONT_END="front-end"
@@ -60,30 +62,64 @@
 CLUSTER_STATIC_NETWORK_PREFIX="192.168.1"
 CLUSTER_SWAP_SIZE=$CONST_NULL_DISK_SIZE
 #
+# All compute nodes.
+#
 COMPUTE_NODE_BRIDGE=$CLUSTER_BRIDGE_NAME
 COMPUTE_NODE_CPUS_FILE=compute-nodes-cpus
 COMPUTE_NODE_DISK_MOUNT_POINT=/mnt/${CONST_COMPUTE_NODE}-system-disk
+COMPUTE_NODE_FSTAB_TEMPLATE=${CONST_FSTAB_FILE_BASENAME}.${CONST_COMPUTE_NODE}
+COMPUTE_NODE_HOME_DISK_FILE_SYSTEM=nfs4
 COMPUTE_NODE_INTERFACES_TEMPLATE=interfaces.${CONST_COMPUTE_NODE}
 COMPUTE_NODE_KERNEL=/boot/vmlinuz-`uname -r`
 COMPUTE_NODE_MAX_NUM=250
-COMPUTE_NODE_MEMORY=3072
-COMPUTE_NODE_MODEL_CLUSTER_STATIC_IP="$CLUSTER_STATIC_NETWORK_PREFIX.$CONST_COMPUTE_NODE_MODEL_CLUSTER_STATIC_NETWORK_POSTFIX"
-COMPUTE_NODE_MODEL_EXTERNAL_MAC_ADDRESS="${CLUSTER_EXTERNAL_MAC_PREFIX}01"
-COMPUTE_NODE_MODEL_STATIC_IP_EXTERNAL=
-COMPUTE_NODE_MODEL_HOST_NAME="tamadi-1-cnm"
-COMPUTE_NODE_MODEL_CLUSTER_HOST_NAME="compute-node-model"
+COMPUTE_NODE_MEMORY=2048
 COMPUTE_NODE_NAME_PREFIX="${CONST_COMPUTE_NODE}-"
 COMPUTE_NODE_RAMDISK=/boot/initrd.img-`uname -r`
 COMPUTE_NODE_STATIC_NETWORK_PREFIX=$CLUSTER_STATIC_NETWORK_PREFIX
 COMPUTE_NODE_SWAP_DISK_POSTFIX=$CONST_SWAP_POSTFIX
 COMPUTE_NODE_SWAP_DISK_PREFIX=$CONST_COMPUTE_NODE
-COMPUTE_NODE_SWAP_DISK_SIZE=1G
-SWAP_DISK_VOLUME_GROUP=/dev/vg_fast
+#COMPUTE_NODE_SWAP_DISK_SIZE=1G
+COMPUTE_NODE_SWAP_DISK_SIZE=$CONST_NULL_DISK_SIZE # No swap disk.
+COMPUTE_NODE_SWAP_DISK_VOLUME_GROUP=vg_fast
+COMPUTE_NODE_SWAP_DISK_VOLUME_GROUP_DEVICE="/dev/$COMPUTE_NODE_SWAP_DISK_VOLUME_GROUP"
+COMPUTE_NODE_SWAP_VIRTUAL_VOLUME=$CONST_XEN_VIRTUAL_DRIVE_2
+COMPUTE_NODE_SYSTEM_DISK_FILE_SYSTEM="ext3"
+COMPUTE_NODE_SYSTEM_VIRTUAL_VOLUME=$CONST_XEN_VIRTUAL_DRIVE_1
 #
+# Compute node model specific.
 #
+COMPUTE_NODE_MODEL_CLUSTER_HOST_NAME="$CONST_COMPUTE_NODE_MODEL"
+COMPUTE_NODE_MODEL_CLUSTER_STATIC_IP="$CLUSTER_STATIC_NETWORK_PREFIX.$CONST_COMPUTE_NODE_MODEL_CLUSTER_STATIC_NETWORK_POSTFIX"
+COMPUTE_NODE_MODEL_CPUS_LIST=20
+COMPUTE_NODE_MODEL_EXTERNAL_INTERFACE_STATIC_NETMASK=255.255.255.0
+COMPUTE_NODE_MODEL_EXTERNAL_INTERFACE_STATIC_NETWORK=140.77.15.0
+COMPUTE_NODE_MODEL_EXTERNAL_INTERFACE_STATIC_GATEWAY=140.77.15.1
+COMPUTE_NODE_MODEL_EXTERNAL_INTERFACE_STATIC_BROADCAST=140.77.15.255
+COMPUTE_NODE_MODEL_EXTERNAL_INTERFACE_STATIC_DNS_NAMESERVERS="140.77.1.32 140.77.167.2"
+COMPUTE_NODE_MODEL_EXTERNAL_INTERFACE_STATIC_DNS_SEARCH="lip.ens-lyon.fr ens-lyon.fr resam.ens-lyon.fr"
+COMPUTE_NODE_MODEL_EXTERNAL_MAC_ADDRESS="${CLUSTER_EXTERNAL_MAC_PREFIX}01"
+COMPUTE_NODE_MODEL_FILE_SYSTEM_MOUNT_POINT=/mnt/compute-node-model-file-system
+COMPUTE_NODE_MODEL_STATIC_IP_EXTERNAL=
+COMPUTE_NODE_MODEL_HOST_NAME="tamadi-1-cnm"
+COMPUTE_NODE_MODEL_INTERFACES_TEMPLATE=interfaces.${CONST_COMPUTE_NODE_MODEL}
+COMPUTE_NODE_MODEL_SWAP_DISK="${CONST_COMPUTE_NODE_MODEL}-${CONST_SWAP_DISK_POSTFIX}"
+COMPUTE_NODE_MODEL_SWAP_DISK_SIZE=$CONST_NULL_DISK_SIZE # No swap disk.
+COMPUTE_NODE_MODEL_SYSTEM_DISK="${CONST_COMPUTE_NODE_MODEL}-${CONST_SYSTEM_DISK_POSTFIX}"
+COMPUTE_NODE_MODEL_SYSTEM_DISK_SIZE=48G
+COMPUTE_NODE_MODEL_SYSTEM_VOLUME_GROUP="vg_slow"
+COMPUTE_NODE_MODEL_SYSTEM_VOLUME_GROUP_DEVICE="/dev/$COMPUTE_NODE_MODEL_SYSTEM_VOLUME_GROUP"
+COMPUTE_NODE_MODEL_SYSTEM_VIRTUAL_VOLUME=$CONST_XEN_VIRTUAL_DRIVE_1
+COMPUTE_NODE_MODEL_SYSTEM_VIRTUAL_VOLUME_DEVICE="/dev/$COMPUTE_NODE_MODEL_SYSTEM_VIRTUAL_VOLUME"
+COMPUTE_NODE_MODEL_VCPUS_NUM=1   # We use the manycores configuration here.
+#
+#
 DOM0_CPUS_LIST="0 4"
 DOM0_CPUS_NUM=2
 DOM0_CPUS_CLAUSE="(dom0-cpus $DOM0_CPUS_NUM)"
+#
+#
+#
+FRONT_END_CLUSTER_HOST_NAME=front-end
 FRONT_END_CLUSTER_STATIC_IP="$CLUSTER_STATIC_NETWORK_PREFIX.$CONST_FRONT_END_CLUSTER_STATIC_NETWORK_POSTFIX"
 FRONT_END_CPUS_LIST="8 12 16"
 FRONT_END_EXPORTS_TEMPLATE=${CONST_EXPORTS_FILE_BASENAME}.${CONST_FRONT_END}
@@ -120,8 +156,8 @@
 FRONT_END_SWAP_VOLUME_GROUP=vg_fast
 FRONT_END_SWAP_VOLUME_GROUP_DEVICE="/dev/$FRONT_END_SWAP_VOLUME_GROUP"
 FRONT_END_SYSTEM_DISK="${CONST_FRONT_END}-${CONST_SYSTEM_DISK_POSTFIX}"
-#FRONT_END_SYSTEM_DISK_SIZE=46G
-FRONT_END_SYSTEM_DISK_SIZE=10G
+FRONT_END_SYSTEM_DISK_SIZE=46G
+#FRONT_END_SYSTEM_DISK_SIZE=10G
 FRONT_END_SYSTEM_DISK_FILE_SYSTEM=ext3
 FRONT_END_SYSTEM_VIRTUAL_VOLUME=$CONST_XEN_VIRTUAL_DRIVE_1
 FRONT_END_SYSTEM_VIRTUAL_VOLUME_DEVICE="/dev/$FRONT_END_SYSTEM_VIRTUAL_VOLUME"