Index: front-end-finish-up
===================================================================
--- front-end-finish-up	(revision 44)
+++ front-end-finish-up	(revision 45)
@@ -25,12 +25,12 @@
 CURRENT_PATH=/etc/xen
 cp templates$CURRENT_PATH/$CONST_FRONT_END_XEN_TEMPLATE_NAME \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
-rpl Template Configuration $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
-rpl __FRONT_END_KERNEL__ $FRONT_END_KERNEL \
+rpl -q Template Configuration $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
+rpl -q __FRONT_END_KERNEL__ $FRONT_END_KERNEL \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
-rpl __FRONT_END_RAMDISK__ $FRONT_END_RAMDISK \
+rpl -q __FRONT_END_RAMDISK__ $FRONT_END_RAMDISK \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
-rpl __FRONT_END_VCPUS_NUM__ $FRONT_END_VCPUS_NUM \
+rpl -q __FRONT_END_VCPUS_NUM__ $FRONT_END_VCPUS_NUM \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 CPUS_LIST=$FRONT_END_CPUS_LIST
 CPUS=""
@@ -43,39 +43,39 @@
         CPUS="$CPUS,$i"
     fi
 done
-rpl __FRONT_END_CPUS__ $CPUS \
+rpl -q __FRONT_END_CPUS__ $CPUS \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # Memory
-rpl __FRONT_END_MEMORY__ $FRONT_END_MEMORY \
+rpl -q __FRONT_END_MEMORY__ $FRONT_END_MEMORY \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # Root device
-rpl __XEN_SYSTEM_DISK_ROOT_DEVICE_STANZA__ "$CONST_XEN_SYSTEM_DISK_ROOT_DEVICE_STANZA" \
+rpl -q __XEN_SYSTEM_DISK_ROOT_DEVICE_STANZA__ "$CONST_XEN_SYSTEM_DISK_ROOT_DEVICE_STANZA" \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 #
 # System disk stuff
 FRONT_END_SYSTEM_DISK_STANZA="'phy:${FRONT_END_SYSTEM_VOLUME_GROUP_DEVICE}/${FRONT_END_SYSTEM_DISK},$FRONT_END_SYSTEM_VIRTUAL_VOLUME,w'"
-rpl __FRONT_END_SYSTEM_DISK_STANZA__ "$FRONT_END_SYSTEM_DISK_STANZA" \
+rpl -q __FRONT_END_SYSTEM_DISK_STANZA__ "$FRONT_END_SYSTEM_DISK_STANZA" \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # Home disk stuff
 FRONT_END_HOME_DISK_STANZA="'phy:${FRONT_END_HOME_VOLUME_GROUP_DEVICE}/${FRONT_END_HOME_DISK},$FRONT_END_HOME_VIRTUAL_VOLUME,w'"
-rpl __FRONT_END_HOME_DISK_STANZA__ "$FRONT_END_HOME_DISK_STANZA" \
+rpl -q __FRONT_END_HOME_DISK_STANZA__ "$FRONT_END_HOME_DISK_STANZA" \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # Swap disk stuff.
 if [ "x$FRONT_END_SWAP_DISK_SIZE" != "x$CONST_NULL_DISK_SIZE" ] ; then
   FRONT_END_SWAP_DISK_STANZA="'phy:${FRONT_END_SWAP_VOLUME_GROUP_DEVICE}/${FRONT_END_SWAP_DISK},$FRONT_END_SWAP_VIRTUAL_VOLUME,w'"
-  rpl __FRONT_END_SWAP_DISK_STANZA__ $FRONT_END_SWAP_DISK_STANZA \
+  rpl -q __FRONT_END_SWAP_DISK_STANZA__ $FRONT_END_SWAP_DISK_STANZA \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
   # Comment out the noswap stanza.
-  rpl __FRONT_END_NOSWAP__ "#$CLUSTER_NOSWAP" \
+  rpl -q __FRONT_END_NOSWAP__ "#$CLUSTER_NOSWAP" \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 else
-  echo y | rpl -f __FRONT_END_SWAP_DISK_STANZA__ "" \
+  rpl -q __FRONT_END_SWAP_DISK_STANZA__ "" \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
-  rpl __FRONT_END_NOSWAP__ $CLUSTER_NOSWAP \
+  rpl -q __FRONT_END_NOSWAP__ $CLUSTER_NOSWAP \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 fi
 #
-rpl __FRONT_END_HOST_NAME__ $CURRENT_HOST_NAME \
+rpl -q __FRONT_END_HOST_NAME__ $CURRENT_HOST_NAME \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # Vif stuff.
 VIF_STANZA=$CONST_XEN_VIF_STANZA_PREFIX
@@ -84,20 +84,20 @@
 INTERNAL_BRIDGE="${CONST_XEN_BRIDGE_PREFIX}${CLUSTER_BRIDGE_NAME}"
 INTERNAL_IP="${CONST_XEN_IP_PREFIX}${FRONT_END_CLUSTER_STATIC_IP}"
 if [ $CLUSTER_EXTERNAL_ADDRESSES_BY_DHCP -eq 1 ] ;then
-  rpl __XEN_DHCP_STANZA__ "$CONST_XEN_DHCP_STANZA" \
+  rpl -q __XEN_DHCP_STANZA__ "$CONST_XEN_DHCP_STANZA" \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
   VIF_STANZA=${VIF_STANZA}${EXTERNAL_MAC}"','"${INTERNAL_IP}","${INTERNAL_MAC}","${INTERNAL_BRIDGE}${CONST_XEN_VIF_STANZA_POSTFIX}
 else
   # Comment out the DHCP_STANZA.
-  rpl __XEN_DHCP_STANZA__ "#$CONST_XEN_DHCP_STANZA" \
+  rpl -q __XEN_DHCP_STANZA__ "#$CONST_XEN_DHCP_STANZA" \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
   VIF_STANZA=${VIF_STANZA}${EXTERNAL_IP}","${EXTERNAL_MAC}",'"${INTERNAL_IP}","${INTERNAL_MAC},${INTERNAL_BRIDGE}${CONST_XEN_VIF_STANZA_POSTFIX}
 fi
 # In any case, write the VIF_STANZA
-rpl __VIF_STANZA__ "$VIF_STANZA" \
+rpl -q __VIF_STANZA__ "$VIF_STANZA" \
    $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # Console stuff as extra parameter
-rpl __EXTRA_STANZA__ "$CONST_XEN_EXTRA_STANZA" \
+rpl -q __EXTRA_STANZA__ "$CONST_XEN_EXTRA_STANZA" \
      $CONST_XEN_CONFIG_DIR/$CURRENT_HOST_NAME.cfg
 # End creation of Xen configuration file.
 #
@@ -142,46 +142,46 @@
    $FRONT_END_FILE_SYSTEM_MOUNT_POINT$CURRENT_PATH/interfaces
 if [ $CLUSTER_EXTERNAL_ADDRESSES_BY_DHCP -eq 1 ] ; then
   ETH0_STANZA="iface eth0 inet dhcp"
-  rpl __ETH0_STATIC_OR_DHCP__ "$ETH0_STANZA"  \
+  rpl -q __ETH0_STATIC_OR_DHCP__ "$ETH0_STANZA"  \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_ADDRESS__ "" \
+  rpl -q __ETH0_STATIC_ADDRESS__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_NETMASK__ "" \
+  rpl -q __ETH0_STATIC_NETMASK__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_NETWORK__ "" \
+  rpl -q __ETH0_STATIC_NETWORK__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_GATEWAY__ "" \
+  rpl -q __ETH0_STATIC_GATEWAY__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_BROADCAST__ "" \
+  rpl -q __ETH0_STATIC_BROADCAST__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_NAMESERVERS__ "" \
+  rpl -q __ETH0_STATIC_NAMESERVERS__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_DNS_SEARCH__ "" \
+  rpl -q __ETH0_STATIC_DNS_SEARCH__ "" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
 else
   ETH0_STANZA="iface eth0 inet static"
-  rpl __ETH0_STATIC_OR_DHCP__ "$ETH0_STANZA"  \
+  rpl -q __ETH0_STATIC_OR_DHCP__ "$ETH0_STANZA"  \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces 
-  echo y | rpl __ETH0_STATIC_ADDRESS__ "$FRONT_END_CLUSTER_STATIC_IP" \
+  rpl -q __ETH0_STATIC_ADDRESS__ "$FRONT_END_CLUSTER_STATIC_IP" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces 
-  echo y | rpl __ETH0_STATIC_NETMASK__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_NETMASK" \
+  rpl -q __ETH0_STATIC_NETMASK__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_NETMASK" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces 
-  echo y | rpl __ETH0_STATIC_NETWORK__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_NETWORK" \
+  rpl -q __ETH0_STATIC_NETWORK__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_NETWORK" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-  echo y | rpl __ETH0_STATIC_GATEWAY__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_GATEWAY" \
+  rpl -q __ETH0_STATIC_GATEWAY__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_GATEWAY" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces 
-  echo y | rpl __ETH0_STATIC_BROADCAST__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_BROADCAST" \
+  rpl -q __ETH0_STATIC_BROADCAST__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_BROADCAST" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces 
-  echo y | rpl __ETH0_STATIC_NAMESERVERS__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_DNS_NAMESERVERS" \
+  rpl -q __ETH0_STATIC_NAMESERVERS__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_DNS_NAMESERVERS" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces 
-  echo y | rpl __ETH0_STATIC_DNS_SEARCH__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_DNS_SEARCH" \
+  rpl-q __ETH0_STATIC_DNS_SEARCH__ "$FRONT_END_EXTERNAL_INTERFACE_STATIC_DNS_SEARCH" \
       ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
 fi 
 # Static address on the cluster interface.
 ADDRESS="${CLUSTER_STATIC_NETWORK_PREFIX}.${CONST_FRONT_END_CLUSTER_STATIC_NETWORK_POSTFIX}"
-rpl __ETH1_STATIC_ADDRESS__ $ADDRESS  \
+rpl -q __ETH1_STATIC_ADDRESS__ $ADDRESS  \
     ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
-rpl __ETH1_STATIC_NETMASK__ $CLUSTER_STATIC_NETMASK  \
+rpl -q __ETH1_STATIC_NETMASK__ $CLUSTER_STATIC_NETMASK  \
     ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/interfaces
     
 # /etc/hostname
@@ -195,9 +195,9 @@
 CURRENT_PATH=/etc
 cp $TEMPLATES_DIR$CURRENT_PATH/resolv.conf \
    ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/resolv.conf
-rpl __CLUSTER_DOMAIN_NAME__ "${CLUSTER_DOMAIN_NAME}." \
+rpl -q __CLUSTER_DOMAIN_NAME__ "${CLUSTER_DOMAIN_NAME}." \
    ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/resolv.conf
-rpl __FRONT_END_STATIC_ADDRESS__ "${CLUSTER_STATIC_NETWORK_PREFIX}.${CONST_FRONT_END_CLUSTER_STATIC_NETWORK_POSTFIX}" \
+rpl -q __FRONT_END_STATIC_ADDRESS__ "${CLUSTER_STATIC_NETWORK_PREFIX}.${CONST_FRONT_END_CLUSTER_STATIC_NETWORK_POSTFIX}" \
    ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/resolv.conf
 #
 # /etc/fstab
@@ -208,12 +208,12 @@
   # Front-End System Disk Line
 FESDL=${FRONT_END_SYSTEM_VIRTUAL_VOLUME_DEVICE}
 FESDL="$FESDL	/		$FRONT_END_SYSTEM_DISK_FILE_SYSTEM	errors=remount-ro	0	1"
-rpl __FRONT_END_SYSTEM_DISK_LINE__ "$FESDL" \
+rpl -q __FRONT_END_SYSTEM_DISK_LINE__ "$FESDL" \
   ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/fstab
   # Font-End Home Disk Line
 FEHDL=${FRONT_END_HOME_VIRTUAL_VOLUME_DEVICE}
 FEHDL="$FEHDL	/home		$FRONT_END_HOME_DISK_FILE_SYSTEM	errors=remount-ro	0	2"
-rpl __FRONT_END_HOME_DISK_LINE__ "$FEHDL" \
+rpl -q __FRONT_END_HOME_DISK_LINE__ "$FEHDL" \
   ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/fstab
   # Font-End Swap Disk Line
 if [ "x$FRONT_END_SWAP_DISK_SIZE" != "x$CONST_NULL_DISK_SIZE" ] ; then
@@ -222,8 +222,8 @@
 else
   FESDL=""
 fi
-# "rpl -f" since $FESDL can be an empty string.
-rpl -f __FRONT_END_SWAP_DISK_LINE__ "$FESDL" \
+# "rpl -q" since $FESDL can be an empty string.
+rpl -q __FRONT_END_SWAP_DISK_LINE__ "$FESDL" \
   ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/fstab
 #
 # End /etc/fstab stuff.
@@ -240,12 +240,12 @@
 cp ${TEMPLATES_DIR}${CURRENT_PATH}/${FRONT_END_EXPORTS_TEMPLATE} \
   ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/$CONST_EXPORTS_FILE_BASENAME
 NFS_HOME_STANZA="$CLUSTER_STATIC_NETWORK_PREFIX.0/${CLUSTER_STATIC_NETMASK}$FRONT_END_NFS_OPTIONS"
-rpl __NFS_HOME_STANZA__ "$NFS_HOME_STANZA" \
+rpl -q __NFS_HOME_STANZA__ "$NFS_HOME_STANZA" \
   ${FRONT_END_FILE_SYSTEM_MOUNT_POINT}${CURRENT_PATH}/$CONST_EXPORTS_FILE_BASENAME
 #
 # End NFS V4 stuff.
 #
-# Umount the compute node system disk
+# Umount the front-end system disk
 #
 # Order matters since the /home file system is mounted on the
 # on the system partition